from __future__ import absolute_import
from __future__ import unicode_literals
from dnfpluginscore import _, logger

import dnf
import dnf.cli
import dnf.exceptions
import fnmatch
import hawkey
import os
import tempfile
import time

class FifLock(dnf.Plugin):

    name = 'fiflock'

    def __init__(self, base, cli):
        super(FifLock, self).__init__(base, cli)
        self.base = base
        self.cli = cli

    def sack(self):
        sack = self.base.sack.query().available()
        fif_pkgs = sack.filter(release__glob = '*.fif[0-9]*')
        fif_pkgs_names = dict((x.name, True) for x in fif_pkgs).keys()
        same_pkgs = sack.filter(name = fif_pkgs_names, pkg__neq = fif_pkgs)

        if same_pkgs:
            logger.info('%d packages excluded by fiflock' % len(same_pkgs))
            self.base.sack.add_excludes(same_pkgs)
